program dbf2maxc;
{$X+}
uses dos;
type
 String255 = string[255];
 String9 = String[9];
 String15 = string[15];
 string80 = string[80];
 string3 = string[3];
 string7 = string[7];
 string10 = string[10];
 string12 = string[12];
 string20 = string[20];
 string40 = string[40];


  Metals = array[1..9] of string3;
  Hs     = array[1..4] of real;
  MLs    = array[1..9] of real;
  MHLs   = array[1..9] of real;
  dHs    = array[1..4] of real;
  dHMCs  = array[1..2,1..9] of real;
  Cmnts  = array[1..9] of string20;

  Kon = array[1..6,1..16] of double;

  KonRec =
    Record
      Chelator : string7;
      H        : Hs;
      dHC      : dHs;
      Metal    : Metals;
      ML       : MLs;
      MHL      : MHLs;
      dHMC     : dHMCs;
      Comments : Cmnts;
    END;


  header = record
   fnm : array[1..10] of char;
   jk1 : byte;
   ftp : char;   {field type}
   jk2 : array[1..4] of byte;
   fln : byte;   {field width}
   dpl : byte;   {dec places}
   jk3 : array[1..14] of byte;
  end;

  dbf = record
   ver : byte;
   yer : byte;
   mon : byte;
   day : byte;
   num : longint;
   hnm : integer;
   rln : integer;
   wst : array[1..20] of byte;
   hd  : array[1..15] of header;
   jk4 : byte;
  end;

  G = record
   wst : char;
   cln : array[1..25] of char;
   h   : array[1..4,1..9] of char;
   dh  : array[1..4,1..9] of char;
   mln : array[1..3] of char;
   ml  : array[1..9] of char;
   mhl : array[1..9] of char;
   dml : array[1..9] of char;
   dmh : array[1..9] of char;
   cmt : array[1..24] of char;
  end;

  database = record
    front : dbf;
    data  : array[1..108] of G;
  end;

  string25 = string[25];
  string24 = string[24];


var dataf2 : file of database;
    ccm : file of konrec;
    ccmr : array[1..12] of konrec;
    OFN,IFN : string80;
    MAXCDBF : database;
    RN2 : integer;
    stuff : searchrec;


 procedure MAKECCM;
 var S7 : string7; S3 : string3; S9 : string9; R : real; E : integer;
     S20 : string20;
     i,j,k :longint;

  procedure clearccmr;
  var i,j : integer;
  begin
   for i := 1 to 12 do
    with ccmr[i] do
     begin
      chelator := '';
      H[1] := 0; H[2] := 0; H[3] := 0; H[4] := 0;
      dHC[1] := 0; dHC[2] := 0; dHC[3] := 0; dHC[4] := 0;
      for j := 1 to 9 do
       begin
        metal[j] := '';
        ML[j] := 0;
        MHL[j] := 0;
        dHMC[1,j] := 0;
        dHMC[2,j] := 0;
        comments[j] := '';
       end;
     end;
  end;

  begin
   clearccmr;
    for i := 1 to 12 do
     with ccmr[i] do
      begin
       for j := 1 to 7 do
        chelator := chelator + MAXCDBF.data[(i*9)-8].cln[j];
       for j := 1 to 4 do
        begin
         s9 := '';
         for k := 1 to 9 do
          s9 := s9 + MAXCDBF.data[(i*9)-8].h[j][k];
         val(s9,H[j],E); if E <> 0 then H[j] := 0;
         s9 := '';
         for k := 1 to 9 do
          s9 := s9 + MAXCDBF.data[(i*9)-8].dh[j][k];
         val(s9,dHC[j],E); if E <> 0 then dHC[j] := 0;
        end;
       {end chelator data, begin metal data for this chelator}
       for j := 1 to 9 do
        begin
         for k := 1 to 3 do
          metal[j] := metal[j] + MAXCDBF.data[(i*9)+j-9].mln[k];
         s9 := '';
         for k := 1 to 9 do
          s9 := s9 + MAXCDBF.data[(i*9)+j-9].ml[k];
         val(s9,ML[j],E); if E <> 0 then ML[j] := 0;
         s9 := '';
         for k := 1 to 9 do
          s9 := s9 + MAXCDBF.data[(i*9)+j-9].mhl[k];
         val(s9,MHL[j],E); if E <> 0 then MHL[j] := 0;
         s9 := '';
         for k := 1 to 9 do
          s9 := s9 + MAXCDBF.data[(i*9)+j-9].dml[k];
         val(s9,dHMC[1,j],E); if E <> 0 then dHMC[1,j] := 0;
         s9 := '';
         for k := 1 to 9 do
          s9 := s9 + MAXCDBF.data[(i*9)+j-9].dmh[k];
         val(s9,dHMC[2,j],E); if E <> 0 then dHMC[2,j] := 0;
         for k := 1 to 20 do
          comments[j] := comments[j] + MAXCDBF.data[(i*9)+j-9].cmt[k];
        end;
      end;
  end;


begin

   write('NAME OF DBASEIII FILE TO CONVERT? ');
   readln(IFN);
   findfirst(IFN,anyfile,stuff);
   if DOSError <> 0 then
    begin
     writeln(IFN,' FILE NOT FOUND');
     exit;
    end;
   if stuff.size <> 17901 then
    begin
     writeln('NOT A PROPER MAXC DATABASE FILE');
     exit;
    end;
   assign(dataf2,IFN);
   {$I-}
   reset(dataf2);
   {$I+}
   if IOResult <> 0 then
    begin
     writeln('UNABLE TO OPEN DBase FILE');
     exit;
    end;
   read(dataf2,MAXCDBF); {read in the ENTIRE database!}
   close(dataf2);
   if (MAXCDBF.FRONT.NUM <> 108)
   or (MAXCDBF.FRONT.HNM <> 513)
   or (MAXCDBF.FRONT.RLN <> 161) then
    begin
     writeln('NOT A PROPER MAXC DATABASE FILE');
     exit;
    end;


   write('NAME OF MAXC CONSTANTS FILE TO SAVEAS? ');
   readln(OFN);
   assign(ccm,OFN);
   {$I-}
   rewrite(ccm);
   {$I+}
   if IOResult <> 0 then
    begin
     writeln('NOT UNABLE TO CREATE CCM FILE');
     exit;
    end;


   MAKECCM;

   for rn2 := 1 to 12 do
    write(ccm,ccmr[rn2]);
   close(ccm);
   writeln('SUCCESSFUL');

end.
