program PCX2EP;
uses dos,printer;                   {only prints to LPT1}
type str8 = string[8];
var Z : array[1..128] of byte;      {the PCX header}
    lgth,width,bpl : integer;       {bpl = bytes/line}
    mono : boolean;                 {only decode monochrome PCX files}
    k : integer;
    PA : array[1..8,1..80] of byte; {decoded PCX data}
    S,T,U,V,W,X : string[128];      {converted epson data}
    f : file;                       {pcx file handle}
    fs : pathstr;                   {pcx file name}
    hi,lo : byte;                   {to set width of graphics on epson}

procedure readpcxhdr;
var yn : char;
begin

 write('Which PCX file to print? ');
 readln(fs);
 assign(f,fs);
 {$I-}
 reset(f,1);
 {$I+}
 if IOResult <> 0 then
  begin
   writeln('CANNOT READ FILE ',FS);
   HALT(1);
  end;
 blockread(f,Z,128);
 lgth  := Z[11] + Z[12]*256 +1;
 width := Z[9]  + Z[10]*256 +1;
 writeln('WIDTH = ',width:3,'  LENGTH = ',lgth:3);
 bpl := Z[67];
 if Z[66] = 1 then mono := true else mono := false;
 writeln(bpl:2,' bytes/line');
 if bpl > 80 then
  begin
   writeln('WIDTH TOO LARGE!');
   halt(1);
  end;
 if (bpl mod 8) <> 0 then
  begin
   writeln('BAD LINE LENGTH'); {must be a multiple of 8}
   halt(1);
  end;
 if NOT mono then
  begin
   writeln('NOT A MONOCHROME PCX FILE');
   halt(1);
  end;
 writeln;
 write('Printer Ready, Continue? Y/N '); {program will crash is printer out}
 readln(YN);
 if NOT (YN in ['y','Y']) then
  begin
   close(f);
   halt(0);
  end;
end;

function ex(i : integer):str8;
var VA : str8; BA : array[1..8] of byte; k : integer;
begin
 {this may seem slow, but is still a lot faster than the printer.
  converts the "horizontal" byte of the PCX file to the "vertical" byte
  needed by the epson printer}

 for k := 1 to 8 do
  BA[k] := 0;
 if (PA[1,i] and 128) = 128 then BA[1] := BA[1] + 128;
 if (PA[2,i] and 128) = 128 then BA[1] := BA[1] +  64;
 if (PA[3,i] and 128) = 128 then BA[1] := BA[1] +  32;
 if (PA[4,i] and 128) = 128 then BA[1] := BA[1] +  16;
 if (PA[5,i] and 128) = 128 then BA[1] := BA[1] +   8;
 if (PA[6,i] and 128) = 128 then BA[1] := BA[1] +   4;
 if (PA[7,i] and 128) = 128 then BA[1] := BA[1] +   2;
 if (PA[8,i] and 128) = 128 then BA[1] := BA[1] +   1;

 if (PA[1,i] and  64) =  64 then BA[2] := BA[2] + 128;
 if (PA[2,i] and  64) =  64 then BA[2] := BA[2] +  64;
 if (PA[3,i] and  64) =  64 then BA[2] := BA[2] +  32;
 if (PA[4,i] and  64) =  64 then BA[2] := BA[2] +  16;
 if (PA[5,i] and  64) =  64 then BA[2] := BA[2] +   8;
 if (PA[6,i] and  64) =  64 then BA[2] := BA[2] +   4;
 if (PA[7,i] and  64) =  64 then BA[2] := BA[2] +   2;
 if (PA[8,i] and  64) =  64 then BA[2] := BA[2] +   1;

 if (PA[1,i] and  32) =  32 then BA[3] := BA[3] + 128;
 if (PA[2,i] and  32) =  32 then BA[3] := BA[3] +  64;
 if (PA[3,i] and  32) =  32 then BA[3] := BA[3] +  32;
 if (PA[4,i] and  32) =  32 then BA[3] := BA[3] +  16;
 if (PA[5,i] and  32) =  32 then BA[3] := BA[3] +   8;
 if (PA[6,i] and  32) =  32 then BA[3] := BA[3] +   4;
 if (PA[7,i] and  32) =  32 then BA[3] := BA[3] +   2;
 if (PA[8,i] and  32) =  32 then BA[3] := BA[3] +   1;

 if (PA[1,i] and  16) =  16 then BA[4] := BA[4] + 128;
 if (PA[2,i] and  16) =  16 then BA[4] := BA[4] +  64;
 if (PA[3,i] and  16) =  16 then BA[4] := BA[4] +  32;
 if (PA[4,i] and  16) =  16 then BA[4] := BA[4] +  16;
 if (PA[5,i] and  16) =  16 then BA[4] := BA[4] +   8;
 if (PA[6,i] and  16) =  16 then BA[4] := BA[4] +   4;
 if (PA[7,i] and  16) =  16 then BA[4] := BA[4] +   2;
 if (PA[8,i] and  16) =  16 then BA[4] := BA[4] +   1;

 if (PA[1,i] and   8) =   8 then BA[5] := BA[5] + 128;
 if (PA[2,i] and   8) =   8 then BA[5] := BA[5] +  64;
 if (PA[3,i] and   8) =   8 then BA[5] := BA[5] +  32;
 if (PA[4,i] and   8) =   8 then BA[5] := BA[5] +  16;
 if (PA[5,i] and   8) =   8 then BA[5] := BA[5] +   8;
 if (PA[6,i] and   8) =   8 then BA[5] := BA[5] +   4;
 if (PA[7,i] and   8) =   8 then BA[5] := BA[5] +   2;
 if (PA[8,i] and   8) =   8 then BA[5] := BA[5] +   1;

 if (PA[1,i] and   4) =   4 then BA[6] := BA[6] + 128;
 if (PA[2,i] and   4) =   4 then BA[6] := BA[6] +  64;
 if (PA[3,i] and   4) =   4 then BA[6] := BA[6] +  32;
 if (PA[4,i] and   4) =   4 then BA[6] := BA[6] +  16;
 if (PA[5,i] and   4) =   4 then BA[6] := BA[6] +   8;
 if (PA[6,i] and   4) =   4 then BA[6] := BA[6] +   4;
 if (PA[7,i] and   4) =   4 then BA[6] := BA[6] +   2;
 if (PA[8,i] and   4) =   4 then BA[6] := BA[6] +   1;

 if (PA[1,i] and   2) =   2 then BA[7] := BA[7] + 128;
 if (PA[2,i] and   2) =   2 then BA[7] := BA[7] +  64;
 if (PA[3,i] and   2) =   2 then BA[7] := BA[7] +  32;
 if (PA[4,i] and   2) =   2 then BA[7] := BA[7] +  16;
 if (PA[5,i] and   2) =   2 then BA[7] := BA[7] +   8;
 if (PA[6,i] and   2) =   2 then BA[7] := BA[7] +   4;
 if (PA[7,i] and   2) =   2 then BA[7] := BA[7] +   2;
 if (PA[8,i] and   2) =   2 then BA[7] := BA[7] +   1;

 if (PA[1,i] and   1) =   1 then BA[8] := BA[8] + 128;
 if (PA[2,i] and   1) =   1 then BA[8] := BA[8] +  64;
 if (PA[3,i] and   1) =   1 then BA[8] := BA[8] +  32;
 if (PA[4,i] and   1) =   1 then BA[8] := BA[8] +  16;
 if (PA[5,i] and   1) =   1 then BA[8] := BA[8] +   8;
 if (PA[6,i] and   1) =   1 then BA[8] := BA[8] +   4;
 if (PA[7,i] and   1) =   1 then BA[8] := BA[8] +   2;
 if (PA[8,i] and   1) =   1 then BA[8] := BA[8] +   1;

 VA := '';
 for k := 1 to 8 do
  VA := VA + chr(BA[k]);
 ex := VA;
end;

procedure fillPA;

procedure clearpa;  {clears the array holding the decoded PCX data}
var i,j : integer;
begin
 for i := 1 to 8 do
  for j := 1 to 80 do
   PA[i,j] := 0;
end;

procedure readpa;   {reads and decodes the PCX data format}
var b : byte; cnt,i,j,k : integer;
begin
 for k := 1 to 8 do
  begin
   j := 1;
   while (j < bpl+1) and (NOT EOF(f)) do
    begin
     blockread(f,b,1);
     if b < 192 then
      begin
       PA[k,j] := 255-b;
       j := j+1;
      end;
     if b > 192 then
      begin
       cnt := b-192;
       if NOT EOF(F) then blockread(f,b,1);
       for i := 1 to cnt do
         PA[k,j+i-1] := 255-b;
       j := j+cnt;
      end;
    end;
  end;
end;

procedure packstr;  {loads the decoded PCX into the strings used to print}
var i : integer;    {would be very simple if bytes/line was always 80}
begin               {but this has been made more flexible than that}
  S := ''; T := ''; U := ''; V := ''; W := '';
  if bpl < 16 then
   begin
    for i := 1 to bpl do
     S := S + ex(i);
    exit;
   end;
  if bpl >= 16 then
   begin
    for i := 1 to 16 do
     S := S + ex(i);
    if bpl = 16 then EXIT;
    if (bpl div 16 = 1) then
     begin
      for i := 17 to bpl do
       T := T + ex(i);
      exit;
     end;
    if bpl >= 32 then
     begin
      for i := 17 to 32 do
       T := T + ex(i);
      if bpl = 32 then EXIT;
      if (bpl div 16 = 2) then
       begin
        for i := 33 to bpl do
         U := U + ex(i);
        exit;
       end;
      if bpl >= 48 then
       begin
        for i := 33 to 48 do
         U := U + ex(i);
        if bpl = 48 then EXIT;
        if (bpl div 16 = 3) then
         begin
          for i := 49 to bpl do
           V := V + ex(i);
          exit;
         end;
        if bpl >= 64 then
         begin
          for i := 49 to 64 do
           V := V + ex(i);
          if bpl = 64 then EXIT;
          for i := 65 to bpl do
           W := W + ex(i);
         end;
       end;
     end;
   end;
end;

begin
 clearpa;
 readpa;
 packstr;
end;

   begin
     readpcxhdr;
     write(Lst,#27+#64+#27+#65+#8); {reset printer, set to 8/72" line spacing}
     hi := width div 256;
     lo := width mod 256;
     X := #27+#42+#4+chr(lo)+chr(hi);{set to 80 dpi, 640/line max}
     for k := 1 to (lgth div 8) do
     begin
      fillPA;
      write(Lst,X);
      write(Lst,S);
      write(LSt,T);
      write(Lst,U);
      write(Lst,V);
      writeln(Lst,W);
      write(k*8:3,#13);
     end;
     write(Lst,#27+#64);  {reset printer}
     close(f);
     writeln('SUCCESSFULL');
  end.

